#! /bin/bash

cd `dirname $0`

service_array=(startConfigmanager.sh data-manager watch-dog cloud-proxy message-router dimu credential fota gateway-monitor task-dispatcher startFC.sh service-monitor RemoteTerminalDaemon driver_manager Debugger DebuggerProxy)

#export LD_LIBRARY_PATH=$(readlink -f ../lib/):$(readlink -f ../lib/db-storage/):$(readlink -f ../lib/pg/):$(readlink -f ../lib/sqlite):$(readlink -f ../usr/lib-sz):$LD_LIBRARY_PATH

pids=`ps -eo user,pid,ppid,stat,args | grep redis | grep -v grep | awk '{print $2}'`
if [ -n "$pids" ]; then
${Q}echo -e "[    \033[0;31m-\033[0m    ]  Stop Running Service: redis"
    kill -9 $pids >>/tmp/linkedge.log 2>&1
fi

start_services(){
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: sst"
	../bin/deploy_sst >>/tmp/linkedge.log 2>&1
    
	#create log dir
	mkdir -p /var/tmp/iiot_aliyun/
	#create mbus mbusd dir
	mkdir -p /var/tmp/var/run/mbusd/
    
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: redis-server"
	cd ../bin && ./redis-server ./../config/redis.conf >>/tmp/linkedge.log 2>&1 &

	#first start the mbus
	cd ../bin && ./mbusd >>/tmp/linkedge.log 2>&1 && cd - &>/dev/null
	sleep 1
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: mbusd"

	#second logger
	cd ../bin && ./logger && cd - &>/dev/null
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: logger"
        for ((i=1; i<=3; i++))
	do
		sleep 1
		../bin/logctl send "start le services...." &>/dev/null
		if [ $? == 0 ]; then
			break
		fi
	done
	
	#third start security
        cd ../bin
	./irot-service &>/dev/null &
	sleep 1
	./keychain-service &>/dev/null &
	sleep 1

	#forth loop start service
	for service in ${service_array[@]}
	do
	cd ../bin
	(./${service} &>/dev/null &)
	cd - &>/dev/null
	${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: ${service}"
	sleep 1
    done
}


${Q}echo "----------------------------------------------------------"
${Q}echo -e "                 \033[32mStart Link IoT Edge Service\033[0m    "
${Q}echo "----------------------------------------------------------"
${Q}echo ""
start_services
../bin/logctl send "system restart...."
${Q}echo ""

